// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"database/sql/driver"
	"fmt"
	"gochassis/ent/chat"
	"gochassis/ent/chatroom"
	"gochassis/ent/predicate"
	"gochassis/ent/profile"
	"math"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// ChatQuery is the builder for querying Chat entities.
type ChatQuery struct {
	config
	ctx             *QueryContext
	order           []chat.Order
	inters          []Interceptor
	predicates      []predicate.Chat
	withProfile     *ProfileQuery
	withChatRoom    *ChatRoomQuery
	withReplyToEdge *ChatQuery
	withReplies     *ChatQuery
	withFKs         bool
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the ChatQuery builder.
func (cq *ChatQuery) Where(ps ...predicate.Chat) *ChatQuery {
	cq.predicates = append(cq.predicates, ps...)
	return cq
}

// Limit the number of records to be returned by this query.
func (cq *ChatQuery) Limit(limit int) *ChatQuery {
	cq.ctx.Limit = &limit
	return cq
}

// Offset to start from.
func (cq *ChatQuery) Offset(offset int) *ChatQuery {
	cq.ctx.Offset = &offset
	return cq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (cq *ChatQuery) Unique(unique bool) *ChatQuery {
	cq.ctx.Unique = &unique
	return cq
}

// Order specifies how the records should be ordered.
func (cq *ChatQuery) Order(o ...chat.Order) *ChatQuery {
	cq.order = append(cq.order, o...)
	return cq
}

// QueryProfile chains the current query on the "profile" edge.
func (cq *ChatQuery) QueryProfile() *ProfileQuery {
	query := (&ProfileClient{config: cq.config}).Query()
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := cq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := cq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(chat.Table, chat.FieldID, selector),
			sqlgraph.To(profile.Table, profile.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, chat.ProfileTable, chat.ProfileColumn),
		)
		fromU = sqlgraph.SetNeighbors(cq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryChatRoom chains the current query on the "chat_room" edge.
func (cq *ChatQuery) QueryChatRoom() *ChatRoomQuery {
	query := (&ChatRoomClient{config: cq.config}).Query()
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := cq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := cq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(chat.Table, chat.FieldID, selector),
			sqlgraph.To(chatroom.Table, chatroom.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, chat.ChatRoomTable, chat.ChatRoomColumn),
		)
		fromU = sqlgraph.SetNeighbors(cq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryReplyToEdge chains the current query on the "reply_to_edge" edge.
func (cq *ChatQuery) QueryReplyToEdge() *ChatQuery {
	query := (&ChatClient{config: cq.config}).Query()
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := cq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := cq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(chat.Table, chat.FieldID, selector),
			sqlgraph.To(chat.Table, chat.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, chat.ReplyToEdgeTable, chat.ReplyToEdgeColumn),
		)
		fromU = sqlgraph.SetNeighbors(cq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryReplies chains the current query on the "replies" edge.
func (cq *ChatQuery) QueryReplies() *ChatQuery {
	query := (&ChatClient{config: cq.config}).Query()
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := cq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := cq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(chat.Table, chat.FieldID, selector),
			sqlgraph.To(chat.Table, chat.FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, chat.RepliesTable, chat.RepliesColumn),
		)
		fromU = sqlgraph.SetNeighbors(cq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first Chat entity from the query.
// Returns a *NotFoundError when no Chat was found.
func (cq *ChatQuery) First(ctx context.Context) (*Chat, error) {
	nodes, err := cq.Limit(1).All(setContextOp(ctx, cq.ctx, "First"))
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{chat.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (cq *ChatQuery) FirstX(ctx context.Context) *Chat {
	node, err := cq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first Chat ID from the query.
// Returns a *NotFoundError when no Chat ID was found.
func (cq *ChatQuery) FirstID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = cq.Limit(1).IDs(setContextOp(ctx, cq.ctx, "FirstID")); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{chat.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (cq *ChatQuery) FirstIDX(ctx context.Context) int {
	id, err := cq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single Chat entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when more than one Chat entity is found.
// Returns a *NotFoundError when no Chat entities are found.
func (cq *ChatQuery) Only(ctx context.Context) (*Chat, error) {
	nodes, err := cq.Limit(2).All(setContextOp(ctx, cq.ctx, "Only"))
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{chat.Label}
	default:
		return nil, &NotSingularError{chat.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (cq *ChatQuery) OnlyX(ctx context.Context) *Chat {
	node, err := cq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only Chat ID in the query.
// Returns a *NotSingularError when more than one Chat ID is found.
// Returns a *NotFoundError when no entities are found.
func (cq *ChatQuery) OnlyID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = cq.Limit(2).IDs(setContextOp(ctx, cq.ctx, "OnlyID")); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{chat.Label}
	default:
		err = &NotSingularError{chat.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (cq *ChatQuery) OnlyIDX(ctx context.Context) int {
	id, err := cq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of Chats.
func (cq *ChatQuery) All(ctx context.Context) ([]*Chat, error) {
	ctx = setContextOp(ctx, cq.ctx, "All")
	if err := cq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	qr := querierAll[[]*Chat, *ChatQuery]()
	return withInterceptors[[]*Chat](ctx, cq, qr, cq.inters)
}

// AllX is like All, but panics if an error occurs.
func (cq *ChatQuery) AllX(ctx context.Context) []*Chat {
	nodes, err := cq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of Chat IDs.
func (cq *ChatQuery) IDs(ctx context.Context) (ids []int, err error) {
	if cq.ctx.Unique == nil && cq.path != nil {
		cq.Unique(true)
	}
	ctx = setContextOp(ctx, cq.ctx, "IDs")
	if err = cq.Select(chat.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (cq *ChatQuery) IDsX(ctx context.Context) []int {
	ids, err := cq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (cq *ChatQuery) Count(ctx context.Context) (int, error) {
	ctx = setContextOp(ctx, cq.ctx, "Count")
	if err := cq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return withInterceptors[int](ctx, cq, querierCount[*ChatQuery](), cq.inters)
}

// CountX is like Count, but panics if an error occurs.
func (cq *ChatQuery) CountX(ctx context.Context) int {
	count, err := cq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (cq *ChatQuery) Exist(ctx context.Context) (bool, error) {
	ctx = setContextOp(ctx, cq.ctx, "Exist")
	switch _, err := cq.FirstID(ctx); {
	case IsNotFound(err):
		return false, nil
	case err != nil:
		return false, fmt.Errorf("ent: check existence: %w", err)
	default:
		return true, nil
	}
}

// ExistX is like Exist, but panics if an error occurs.
func (cq *ChatQuery) ExistX(ctx context.Context) bool {
	exist, err := cq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the ChatQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (cq *ChatQuery) Clone() *ChatQuery {
	if cq == nil {
		return nil
	}
	return &ChatQuery{
		config:          cq.config,
		ctx:             cq.ctx.Clone(),
		order:           append([]chat.Order{}, cq.order...),
		inters:          append([]Interceptor{}, cq.inters...),
		predicates:      append([]predicate.Chat{}, cq.predicates...),
		withProfile:     cq.withProfile.Clone(),
		withChatRoom:    cq.withChatRoom.Clone(),
		withReplyToEdge: cq.withReplyToEdge.Clone(),
		withReplies:     cq.withReplies.Clone(),
		// clone intermediate query.
		sql:  cq.sql.Clone(),
		path: cq.path,
	}
}

// WithProfile tells the query-builder to eager-load the nodes that are connected to
// the "profile" edge. The optional arguments are used to configure the query builder of the edge.
func (cq *ChatQuery) WithProfile(opts ...func(*ProfileQuery)) *ChatQuery {
	query := (&ProfileClient{config: cq.config}).Query()
	for _, opt := range opts {
		opt(query)
	}
	cq.withProfile = query
	return cq
}

// WithChatRoom tells the query-builder to eager-load the nodes that are connected to
// the "chat_room" edge. The optional arguments are used to configure the query builder of the edge.
func (cq *ChatQuery) WithChatRoom(opts ...func(*ChatRoomQuery)) *ChatQuery {
	query := (&ChatRoomClient{config: cq.config}).Query()
	for _, opt := range opts {
		opt(query)
	}
	cq.withChatRoom = query
	return cq
}

// WithReplyToEdge tells the query-builder to eager-load the nodes that are connected to
// the "reply_to_edge" edge. The optional arguments are used to configure the query builder of the edge.
func (cq *ChatQuery) WithReplyToEdge(opts ...func(*ChatQuery)) *ChatQuery {
	query := (&ChatClient{config: cq.config}).Query()
	for _, opt := range opts {
		opt(query)
	}
	cq.withReplyToEdge = query
	return cq
}

// WithReplies tells the query-builder to eager-load the nodes that are connected to
// the "replies" edge. The optional arguments are used to configure the query builder of the edge.
func (cq *ChatQuery) WithReplies(opts ...func(*ChatQuery)) *ChatQuery {
	query := (&ChatClient{config: cq.config}).Query()
	for _, opt := range opts {
		opt(query)
	}
	cq.withReplies = query
	return cq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		Text string `json:"text,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.Chat.Query().
//		GroupBy(chat.FieldText).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
func (cq *ChatQuery) GroupBy(field string, fields ...string) *ChatGroupBy {
	cq.ctx.Fields = append([]string{field}, fields...)
	grbuild := &ChatGroupBy{build: cq}
	grbuild.flds = &cq.ctx.Fields
	grbuild.label = chat.Label
	grbuild.scan = grbuild.Scan
	return grbuild
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		Text string `json:"text,omitempty"`
//	}
//
//	client.Chat.Query().
//		Select(chat.FieldText).
//		Scan(ctx, &v)
func (cq *ChatQuery) Select(fields ...string) *ChatSelect {
	cq.ctx.Fields = append(cq.ctx.Fields, fields...)
	sbuild := &ChatSelect{ChatQuery: cq}
	sbuild.label = chat.Label
	sbuild.flds, sbuild.scan = &cq.ctx.Fields, sbuild.Scan
	return sbuild
}

// Aggregate returns a ChatSelect configured with the given aggregations.
func (cq *ChatQuery) Aggregate(fns ...AggregateFunc) *ChatSelect {
	return cq.Select().Aggregate(fns...)
}

func (cq *ChatQuery) prepareQuery(ctx context.Context) error {
	for _, inter := range cq.inters {
		if inter == nil {
			return fmt.Errorf("ent: uninitialized interceptor (forgotten import ent/runtime?)")
		}
		if trv, ok := inter.(Traverser); ok {
			if err := trv.Traverse(ctx, cq); err != nil {
				return err
			}
		}
	}
	for _, f := range cq.ctx.Fields {
		if !chat.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if cq.path != nil {
		prev, err := cq.path(ctx)
		if err != nil {
			return err
		}
		cq.sql = prev
	}
	return nil
}

func (cq *ChatQuery) sqlAll(ctx context.Context, hooks ...queryHook) ([]*Chat, error) {
	var (
		nodes       = []*Chat{}
		withFKs     = cq.withFKs
		_spec       = cq.querySpec()
		loadedTypes = [4]bool{
			cq.withProfile != nil,
			cq.withChatRoom != nil,
			cq.withReplyToEdge != nil,
			cq.withReplies != nil,
		}
	)
	if cq.withProfile != nil || cq.withChatRoom != nil {
		withFKs = true
	}
	if withFKs {
		_spec.Node.Columns = append(_spec.Node.Columns, chat.ForeignKeys...)
	}
	_spec.ScanValues = func(columns []string) ([]any, error) {
		return (*Chat).scanValues(nil, columns)
	}
	_spec.Assign = func(columns []string, values []any) error {
		node := &Chat{config: cq.config}
		nodes = append(nodes, node)
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	for i := range hooks {
		hooks[i](ctx, _spec)
	}
	if err := sqlgraph.QueryNodes(ctx, cq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}
	if query := cq.withProfile; query != nil {
		if err := cq.loadProfile(ctx, query, nodes, nil,
			func(n *Chat, e *Profile) { n.Edges.Profile = e }); err != nil {
			return nil, err
		}
	}
	if query := cq.withChatRoom; query != nil {
		if err := cq.loadChatRoom(ctx, query, nodes, nil,
			func(n *Chat, e *ChatRoom) { n.Edges.ChatRoom = e }); err != nil {
			return nil, err
		}
	}
	if query := cq.withReplyToEdge; query != nil {
		if err := cq.loadReplyToEdge(ctx, query, nodes, nil,
			func(n *Chat, e *Chat) { n.Edges.ReplyToEdge = e }); err != nil {
			return nil, err
		}
	}
	if query := cq.withReplies; query != nil {
		if err := cq.loadReplies(ctx, query, nodes,
			func(n *Chat) { n.Edges.Replies = []*Chat{} },
			func(n *Chat, e *Chat) { n.Edges.Replies = append(n.Edges.Replies, e) }); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

func (cq *ChatQuery) loadProfile(ctx context.Context, query *ProfileQuery, nodes []*Chat, init func(*Chat), assign func(*Chat, *Profile)) error {
	ids := make([]int, 0, len(nodes))
	nodeids := make(map[int][]*Chat)
	for i := range nodes {
		if nodes[i].profile_chats == nil {
			continue
		}
		fk := *nodes[i].profile_chats
		if _, ok := nodeids[fk]; !ok {
			ids = append(ids, fk)
		}
		nodeids[fk] = append(nodeids[fk], nodes[i])
	}
	if len(ids) == 0 {
		return nil
	}
	query.Where(profile.IDIn(ids...))
	neighbors, err := query.All(ctx)
	if err != nil {
		return err
	}
	for _, n := range neighbors {
		nodes, ok := nodeids[n.ID]
		if !ok {
			return fmt.Errorf(`unexpected foreign-key "profile_chats" returned %v`, n.ID)
		}
		for i := range nodes {
			assign(nodes[i], n)
		}
	}
	return nil
}
func (cq *ChatQuery) loadChatRoom(ctx context.Context, query *ChatRoomQuery, nodes []*Chat, init func(*Chat), assign func(*Chat, *ChatRoom)) error {
	ids := make([]int, 0, len(nodes))
	nodeids := make(map[int][]*Chat)
	for i := range nodes {
		if nodes[i].chat_room_chats == nil {
			continue
		}
		fk := *nodes[i].chat_room_chats
		if _, ok := nodeids[fk]; !ok {
			ids = append(ids, fk)
		}
		nodeids[fk] = append(nodeids[fk], nodes[i])
	}
	if len(ids) == 0 {
		return nil
	}
	query.Where(chatroom.IDIn(ids...))
	neighbors, err := query.All(ctx)
	if err != nil {
		return err
	}
	for _, n := range neighbors {
		nodes, ok := nodeids[n.ID]
		if !ok {
			return fmt.Errorf(`unexpected foreign-key "chat_room_chats" returned %v`, n.ID)
		}
		for i := range nodes {
			assign(nodes[i], n)
		}
	}
	return nil
}
func (cq *ChatQuery) loadReplyToEdge(ctx context.Context, query *ChatQuery, nodes []*Chat, init func(*Chat), assign func(*Chat, *Chat)) error {
	ids := make([]int, 0, len(nodes))
	nodeids := make(map[int][]*Chat)
	for i := range nodes {
		fk := nodes[i].ReplyTo
		if _, ok := nodeids[fk]; !ok {
			ids = append(ids, fk)
		}
		nodeids[fk] = append(nodeids[fk], nodes[i])
	}
	if len(ids) == 0 {
		return nil
	}
	query.Where(chat.IDIn(ids...))
	neighbors, err := query.All(ctx)
	if err != nil {
		return err
	}
	for _, n := range neighbors {
		nodes, ok := nodeids[n.ID]
		if !ok {
			return fmt.Errorf(`unexpected foreign-key "reply_to" returned %v`, n.ID)
		}
		for i := range nodes {
			assign(nodes[i], n)
		}
	}
	return nil
}
func (cq *ChatQuery) loadReplies(ctx context.Context, query *ChatQuery, nodes []*Chat, init func(*Chat), assign func(*Chat, *Chat)) error {
	fks := make([]driver.Value, 0, len(nodes))
	nodeids := make(map[int]*Chat)
	for i := range nodes {
		fks = append(fks, nodes[i].ID)
		nodeids[nodes[i].ID] = nodes[i]
		if init != nil {
			init(nodes[i])
		}
	}
	query.withFKs = true
	query.Where(predicate.Chat(func(s *sql.Selector) {
		s.Where(sql.InValues(chat.RepliesColumn, fks...))
	}))
	neighbors, err := query.All(ctx)
	if err != nil {
		return err
	}
	for _, n := range neighbors {
		fk := n.ReplyTo
		node, ok := nodeids[fk]
		if !ok {
			return fmt.Errorf(`unexpected foreign-key "reply_to" returned %v for node %v`, fk, n.ID)
		}
		assign(node, n)
	}
	return nil
}

func (cq *ChatQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := cq.querySpec()
	_spec.Node.Columns = cq.ctx.Fields
	if len(cq.ctx.Fields) > 0 {
		_spec.Unique = cq.ctx.Unique != nil && *cq.ctx.Unique
	}
	return sqlgraph.CountNodes(ctx, cq.driver, _spec)
}

func (cq *ChatQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := sqlgraph.NewQuerySpec(chat.Table, chat.Columns, sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt))
	_spec.From = cq.sql
	if unique := cq.ctx.Unique; unique != nil {
		_spec.Unique = *unique
	} else if cq.path != nil {
		_spec.Unique = true
	}
	if fields := cq.ctx.Fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, chat.FieldID)
		for i := range fields {
			if fields[i] != chat.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
		if cq.withReplyToEdge != nil {
			_spec.Node.AddColumnOnce(chat.FieldReplyTo)
		}
	}
	if ps := cq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := cq.ctx.Limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := cq.ctx.Offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := cq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (cq *ChatQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(cq.driver.Dialect())
	t1 := builder.Table(chat.Table)
	columns := cq.ctx.Fields
	if len(columns) == 0 {
		columns = chat.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if cq.sql != nil {
		selector = cq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	if cq.ctx.Unique != nil && *cq.ctx.Unique {
		selector.Distinct()
	}
	for _, p := range cq.predicates {
		p(selector)
	}
	for _, p := range cq.order {
		p(selector)
	}
	if offset := cq.ctx.Offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := cq.ctx.Limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// ChatGroupBy is the group-by builder for Chat entities.
type ChatGroupBy struct {
	selector
	build *ChatQuery
}

// Aggregate adds the given aggregation functions to the group-by query.
func (cgb *ChatGroupBy) Aggregate(fns ...AggregateFunc) *ChatGroupBy {
	cgb.fns = append(cgb.fns, fns...)
	return cgb
}

// Scan applies the selector query and scans the result into the given value.
func (cgb *ChatGroupBy) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, cgb.build.ctx, "GroupBy")
	if err := cgb.build.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*ChatQuery, *ChatGroupBy](ctx, cgb.build, cgb, cgb.build.inters, v)
}

func (cgb *ChatGroupBy) sqlScan(ctx context.Context, root *ChatQuery, v any) error {
	selector := root.sqlQuery(ctx).Select()
	aggregation := make([]string, 0, len(cgb.fns))
	for _, fn := range cgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(*cgb.flds)+len(cgb.fns))
		for _, f := range *cgb.flds {
			columns = append(columns, selector.C(f))
		}
		columns = append(columns, aggregation...)
		selector.Select(columns...)
	}
	selector.GroupBy(selector.Columns(*cgb.flds...)...)
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := cgb.build.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

// ChatSelect is the builder for selecting fields of Chat entities.
type ChatSelect struct {
	*ChatQuery
	selector
}

// Aggregate adds the given aggregation functions to the selector query.
func (cs *ChatSelect) Aggregate(fns ...AggregateFunc) *ChatSelect {
	cs.fns = append(cs.fns, fns...)
	return cs
}

// Scan applies the selector query and scans the result into the given value.
func (cs *ChatSelect) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, cs.ctx, "Select")
	if err := cs.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*ChatQuery, *ChatSelect](ctx, cs.ChatQuery, cs, cs.inters, v)
}

func (cs *ChatSelect) sqlScan(ctx context.Context, root *ChatQuery, v any) error {
	selector := root.sqlQuery(ctx)
	aggregation := make([]string, 0, len(cs.fns))
	for _, fn := range cs.fns {
		aggregation = append(aggregation, fn(selector))
	}
	switch n := len(*cs.selector.flds); {
	case n == 0 && len(aggregation) > 0:
		selector.Select(aggregation...)
	case n != 0 && len(aggregation) > 0:
		selector.AppendSelect(aggregation...)
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := cs.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
